package com.yuandian.dataflow.statemachine.messages;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;

import org.apache.ratis.protocol.Message;
import org.apache.ratis.thirdparty.com.google.protobuf.ByteString;

@java.lang.SuppressWarnings("unchecked")

public class MessageUtils {
    
     public static  <T> T fromMessage(Message msg) throws IOException, ClassNotFoundException {
        var inBytes = new ByteArrayInputStream(msg.getContent().toByteArray());
        var inObject = new ObjectInputStream(inBytes);
        T result = (T) inObject.readObject();
        inObject.close();
        inBytes.close();
        return result;
    }

    public static  <T> T fromByteString(ByteString msg) throws IOException, ClassNotFoundException {
        var inBytes = new ByteArrayInputStream(msg.toByteArray());
        var inObject = new ObjectInputStream(inBytes);
        T result = (T) inObject.readObject();
        inObject.close();
        inBytes.close();
        return result;
    }
}
